// Copyright (c) 2005-2014 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#include "conf.hxx"

// Configuration
// 

const Configuration::ParamSequence& Configuration::
param () const
{
  return this->param_;
}

Configuration::ParamSequence& Configuration::
param ()
{
  return this->param_;
}

void Configuration::
param (const ParamSequence& s)
{
  this->param_ = s;
}

const Configuration::OcspSequence& Configuration::
ocsp () const
{
  return this->ocsp_;
}

Configuration::OcspSequence& Configuration::
ocsp ()
{
  return this->ocsp_;
}

void Configuration::
ocsp (const OcspSequence& s)
{
  this->ocsp_ = s;
}


// Ocsp
// 

const Ocsp::IssuerType& Ocsp::
issuer () const
{
  return this->issuer_.get ();
}

Ocsp::IssuerType& Ocsp::
issuer ()
{
  return this->issuer_.get ();
}

void Ocsp::
issuer (const IssuerType& x)
{
  this->issuer_.set (x);
}

void Ocsp::
issuer (::std::unique_ptr< IssuerType > x)
{
  this->issuer_.set (std::move (x));
}


// Param
// 

const Param::NameType& Param::
name () const
{
  return this->name_.get ();
}

Param::NameType& Param::
name ()
{
  return this->name_.get ();
}

void Param::
name (const NameType& x)
{
  this->name_.set (x);
}

void Param::
name (::std::unique_ptr< NameType > x)
{
  this->name_.set (std::move (x));
}

const Param::LockOptional& Param::
lock () const
{
  return this->lock_;
}

Param::LockOptional& Param::
lock ()
{
  return this->lock_;
}

void Param::
lock (const LockType& x)
{
  this->lock_.set (x);
}

void Param::
lock (const LockOptional& x)
{
  this->lock_ = x;
}


#include <xsd/cxx/xml/dom/parsing-source.hxx>

// Configuration
//

Configuration::
Configuration ()
: ::xml_schema::Type (),
  param_ (this),
  ocsp_ (this)
{
}

Configuration::
Configuration (const Configuration& x,
               ::xml_schema::Flags f,
               ::xml_schema::Container* c)
: ::xml_schema::Type (x, f, c),
  param_ (x.param_, f, this),
  ocsp_ (x.ocsp_, f, this)
{
}

Configuration::
Configuration (const ::xercesc::DOMElement& e,
               ::xml_schema::Flags f,
               ::xml_schema::Container* c)
: ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
  param_ (this),
  ocsp_ (this)
{
  if ((f & ::xml_schema::Flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
    this->parse (p, f);
  }
}

void Configuration::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::Flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // param
    //
    if (n.name () == "param" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< ParamType > r (
        ParamTraits::create (i, f, this));

      this->param_.push_back (::std::move (r));
      continue;
    }

    // ocsp
    //
    if (n.name () == "ocsp" && n.namespace_ ().empty ())
    {
      ::std::unique_ptr< OcspType > r (
        OcspTraits::create (i, f, this));

      this->ocsp_.push_back (::std::move (r));
      continue;
    }

    break;
  }
}

Configuration* Configuration::
_clone (::xml_schema::Flags f,
        ::xml_schema::Container* c) const
{
  return new class Configuration (*this, f, c);
}

Configuration::
~Configuration ()
{
}

// Ocsp
//

Ocsp::
Ocsp (const IssuerType& issuer)
: ::xml_schema::String (),
  issuer_ (issuer, this)
{
}

Ocsp::
Ocsp (const char* _xsd_String_base,
      const IssuerType& issuer)
: ::xml_schema::String (_xsd_String_base),
  issuer_ (issuer, this)
{
}

Ocsp::
Ocsp (const ::std::string& _xsd_String_base,
      const IssuerType& issuer)
: ::xml_schema::String (_xsd_String_base),
  issuer_ (issuer, this)
{
}

Ocsp::
Ocsp (const ::xml_schema::String& _xsd_String_base,
      const IssuerType& issuer)
: ::xml_schema::String (_xsd_String_base),
  issuer_ (issuer, this)
{
}

Ocsp::
Ocsp (const Ocsp& x,
      ::xml_schema::Flags f,
      ::xml_schema::Container* c)
: ::xml_schema::String (x, f, c),
  issuer_ (x.issuer_, f, this)
{
}

Ocsp::
Ocsp (const ::xercesc::DOMElement& e,
      ::xml_schema::Flags f,
      ::xml_schema::Container* c)
: ::xml_schema::String (e, f | ::xml_schema::Flags::base, c),
  issuer_ (this)
{
  if ((f & ::xml_schema::Flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
    this->parse (p, f);
  }
}

void Ocsp::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::Flags f)
{
  while (p.more_attributes ())
  {
    const ::xercesc::DOMAttr& i (p.next_attribute ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    if (n.name () == "issuer" && n.namespace_ ().empty ())
    {
      this->issuer_.set (IssuerTraits::create (i, f, this));
      continue;
    }
  }

  if (!issuer_.present ())
  {
    throw ::xsd::cxx::tree::expected_attribute< char > (
      "issuer",
      "");
  }
}

Ocsp* Ocsp::
_clone (::xml_schema::Flags f,
        ::xml_schema::Container* c) const
{
  return new class Ocsp (*this, f, c);
}

Ocsp::
~Ocsp ()
{
}

// Param
//

Param::
Param (const NameType& name)
: ::xml_schema::String (),
  name_ (name, this),
  lock_ (this)
{
}

Param::
Param (const char* _xsd_String_base,
       const NameType& name)
: ::xml_schema::String (_xsd_String_base),
  name_ (name, this),
  lock_ (this)
{
}

Param::
Param (const ::std::string& _xsd_String_base,
       const NameType& name)
: ::xml_schema::String (_xsd_String_base),
  name_ (name, this),
  lock_ (this)
{
}

Param::
Param (const ::xml_schema::String& _xsd_String_base,
       const NameType& name)
: ::xml_schema::String (_xsd_String_base),
  name_ (name, this),
  lock_ (this)
{
}

Param::
Param (const Param& x,
       ::xml_schema::Flags f,
       ::xml_schema::Container* c)
: ::xml_schema::String (x, f, c),
  name_ (x.name_, f, this),
  lock_ (x.lock_, f, this)
{
}

Param::
Param (const ::xercesc::DOMElement& e,
       ::xml_schema::Flags f,
       ::xml_schema::Container* c)
: ::xml_schema::String (e, f | ::xml_schema::Flags::base, c),
  name_ (this),
  lock_ (this)
{
  if ((f & ::xml_schema::Flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
    this->parse (p, f);
  }
}

void Param::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::Flags f)
{
  while (p.more_attributes ())
  {
    const ::xercesc::DOMAttr& i (p.next_attribute ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    if (n.name () == "name" && n.namespace_ ().empty ())
    {
      this->name_.set (NameTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "lock" && n.namespace_ ().empty ())
    {
      this->lock_.set (LockTraits::create (i, f, this));
      continue;
    }
  }

  if (!name_.present ())
  {
    throw ::xsd::cxx::tree::expected_attribute< char > (
      "name",
      "");
  }
}

Param* Param::
_clone (::xml_schema::Flags f,
        ::xml_schema::Container* c) const
{
  return new class Param (*this, f, c);
}

Param::
~Param ()
{
}

#include <istream>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

::std::unique_ptr< ::Configuration >
configuration (const ::std::string& u,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0,
    (f & ::xml_schema::Flags::keep_dom) == 0);

  ::xsd::cxx::tree::error_handler< char > h;

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      u, h, p, f));

  h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

  return ::std::unique_ptr< ::Configuration > (
    ::configuration (
      std::move (d), f | ::xml_schema::Flags::own_dom, p));
}

::std::unique_ptr< ::Configuration >
configuration (const ::std::string& u,
               ::xml_schema::ErrorHandler& h,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0,
    (f & ::xml_schema::Flags::keep_dom) == 0);

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      u, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::Configuration > (
    ::configuration (
      std::move (d), f | ::xml_schema::Flags::own_dom, p));
}

::std::unique_ptr< ::Configuration >
configuration (const ::std::string& u,
               ::xercesc::DOMErrorHandler& h,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      u, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::Configuration > (
    ::configuration (
      std::move (d), f | ::xml_schema::Flags::own_dom, p));
}

::std::unique_ptr< ::Configuration >
configuration (::std::istream& is,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0,
    (f & ::xml_schema::Flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is);
  return ::configuration (isrc, f, p);
}

::std::unique_ptr< ::Configuration >
configuration (::std::istream& is,
               ::xml_schema::ErrorHandler& h,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0,
    (f & ::xml_schema::Flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is);
  return ::configuration (isrc, h, f, p);
}

::std::unique_ptr< ::Configuration >
configuration (::std::istream& is,
               ::xercesc::DOMErrorHandler& h,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::sax::std_input_source isrc (is);
  return ::configuration (isrc, h, f, p);
}

::std::unique_ptr< ::Configuration >
configuration (::std::istream& is,
               const ::std::string& sid,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0,
    (f & ::xml_schema::Flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
  return ::configuration (isrc, f, p);
}

::std::unique_ptr< ::Configuration >
configuration (::std::istream& is,
               const ::std::string& sid,
               ::xml_schema::ErrorHandler& h,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0,
    (f & ::xml_schema::Flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
  return ::configuration (isrc, h, f, p);
}

::std::unique_ptr< ::Configuration >
configuration (::std::istream& is,
               const ::std::string& sid,
               ::xercesc::DOMErrorHandler& h,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
  return ::configuration (isrc, h, f, p);
}

::std::unique_ptr< ::Configuration >
configuration (::xercesc::InputSource& i,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  ::xsd::cxx::tree::error_handler< char > h;

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      i, h, p, f));

  h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

  return ::std::unique_ptr< ::Configuration > (
    ::configuration (
      std::move (d), f | ::xml_schema::Flags::own_dom, p));
}

::std::unique_ptr< ::Configuration >
configuration (::xercesc::InputSource& i,
               ::xml_schema::ErrorHandler& h,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      i, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::Configuration > (
    ::configuration (
      std::move (d), f | ::xml_schema::Flags::own_dom, p));
}

::std::unique_ptr< ::Configuration >
configuration (::xercesc::InputSource& i,
               ::xercesc::DOMErrorHandler& h,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      i, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::Configuration > (
    ::configuration (
      std::move (d), f | ::xml_schema::Flags::own_dom, p));
}

::std::unique_ptr< ::Configuration >
configuration (const ::xercesc::DOMDocument& doc,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties& p)
{
  if (f & ::xml_schema::Flags::keep_dom)
  {
    ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
      static_cast< ::xercesc::DOMDocument* > (doc.cloneNode (true)));

    return ::std::unique_ptr< ::Configuration > (
      ::configuration (
        std::move (d), f | ::xml_schema::Flags::own_dom, p));
  }

  const ::xercesc::DOMElement& e (*doc.getDocumentElement ());
  const ::xsd::cxx::xml::qualified_name< char > n (
    ::xsd::cxx::xml::dom::name< char > (e));

  if (n.name () == "configuration" &&
      n.namespace_ () == "")
  {
    ::std::unique_ptr< ::Configuration > r (
      ::xsd::cxx::tree::traits< ::Configuration, char >::create (
        e, f, 0));
    return r;
  }

  throw ::xsd::cxx::tree::unexpected_element < char > (
    n.name (),
    n.namespace_ (),
    "configuration",
    "");
}

::std::unique_ptr< ::Configuration >
configuration (::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d,
               ::xml_schema::Flags f,
               const ::xml_schema::Properties&)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > c (
    ((f & ::xml_schema::Flags::keep_dom) &&
     !(f & ::xml_schema::Flags::own_dom))
    ? static_cast< ::xercesc::DOMDocument* > (d->cloneNode (true))
    : 0);

  ::xercesc::DOMDocument& doc (c.get () ? *c : *d);
  const ::xercesc::DOMElement& e (*doc.getDocumentElement ());

  const ::xsd::cxx::xml::qualified_name< char > n (
    ::xsd::cxx::xml::dom::name< char > (e));

  if (f & ::xml_schema::Flags::keep_dom)
    doc.setUserData (::xml_schema::dom::treeNodeKey,
                     (c.get () ? &c : &d),
                     0);

  if (n.name () == "configuration" &&
      n.namespace_ () == "")
  {
    ::std::unique_ptr< ::Configuration > r (
      ::xsd::cxx::tree::traits< ::Configuration, char >::create (
        e, f, 0));
    return r;
  }

  throw ::xsd::cxx::tree::unexpected_element < char > (
    n.name (),
    n.namespace_ (),
    "configuration",
    "");
}

#include <ostream>
#include <xsd/cxx/tree/error-handler.hxx>
#include <xsd/cxx/xml/dom/serialization-source.hxx>

void
configuration (::std::ostream& o,
               const ::Configuration& s,
               const ::xml_schema::NamespaceInfomap& m,
               const ::std::string& e,
               ::xml_schema::Flags f)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0);

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::configuration (s, m, f));

  ::xsd::cxx::tree::error_handler< char > h;

  ::xsd::cxx::xml::dom::ostream_format_target t (o);
  if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
  {
    h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
  }
}

void
configuration (::std::ostream& o,
               const ::Configuration& s,
               ::xml_schema::ErrorHandler& h,
               const ::xml_schema::NamespaceInfomap& m,
               const ::std::string& e,
               ::xml_schema::Flags f)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0);

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::configuration (s, m, f));
  ::xsd::cxx::xml::dom::ostream_format_target t (o);
  if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
  {
    throw ::xsd::cxx::tree::serialization< char > ();
  }
}

void
configuration (::std::ostream& o,
               const ::Configuration& s,
               ::xercesc::DOMErrorHandler& h,
               const ::xml_schema::NamespaceInfomap& m,
               const ::std::string& e,
               ::xml_schema::Flags f)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::configuration (s, m, f));
  ::xsd::cxx::xml::dom::ostream_format_target t (o);
  if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
  {
    throw ::xsd::cxx::tree::serialization< char > ();
  }
}

void
configuration (::xercesc::XMLFormatTarget& t,
               const ::Configuration& s,
               const ::xml_schema::NamespaceInfomap& m,
               const ::std::string& e,
               ::xml_schema::Flags f)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::configuration (s, m, f));

  ::xsd::cxx::tree::error_handler< char > h;

  if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
  {
    h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
  }
}

void
configuration (::xercesc::XMLFormatTarget& t,
               const ::Configuration& s,
               ::xml_schema::ErrorHandler& h,
               const ::xml_schema::NamespaceInfomap& m,
               const ::std::string& e,
               ::xml_schema::Flags f)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::configuration (s, m, f));
  if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
  {
    throw ::xsd::cxx::tree::serialization< char > ();
  }
}

void
configuration (::xercesc::XMLFormatTarget& t,
               const ::Configuration& s,
               ::xercesc::DOMErrorHandler& h,
               const ::xml_schema::NamespaceInfomap& m,
               const ::std::string& e,
               ::xml_schema::Flags f)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::configuration (s, m, f));
  if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
  {
    throw ::xsd::cxx::tree::serialization< char > ();
  }
}

void
configuration (::xercesc::DOMDocument& d,
               const ::Configuration& s,
               ::xml_schema::Flags)
{
  ::xercesc::DOMElement& e (*d.getDocumentElement ());
  const ::xsd::cxx::xml::qualified_name< char > n (
    ::xsd::cxx::xml::dom::name< char > (e));

  if (n.name () == "configuration" &&
      n.namespace_ () == "")
  {
    e << s;
  }
  else
  {
    throw ::xsd::cxx::tree::unexpected_element < char > (
      n.name (),
      n.namespace_ (),
      "configuration",
      "");
  }
}

::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument >
configuration (const ::Configuration& s,
               const ::xml_schema::NamespaceInfomap& m,
               ::xml_schema::Flags f)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::serialize< char > (
      "configuration",
      "",
      m, f));

  ::configuration (*d, s, f);
  return d;
}

void
operator<< (::xercesc::DOMElement& e, const Configuration& i)
{
  e << static_cast< const ::xml_schema::Type& > (i);

  // param
  //
  for (Configuration::ParamConstIterator
       b (i.param ().begin ()), n (i.param ().end ());
       b != n; ++b)
  {
    ::xercesc::DOMElement& s (
      ::xsd::cxx::xml::dom::create_element (
        "param",
        e));

    s << *b;
  }

  // ocsp
  //
  for (Configuration::OcspConstIterator
       b (i.ocsp ().begin ()), n (i.ocsp ().end ());
       b != n; ++b)
  {
    ::xercesc::DOMElement& s (
      ::xsd::cxx::xml::dom::create_element (
        "ocsp",
        e));

    s << *b;
  }
}

void
operator<< (::xercesc::DOMElement& e, const Ocsp& i)
{
  e << static_cast< const ::xml_schema::String& > (i);

  // issuer
  //
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "issuer",
        e));

    a << i.issuer ();
  }
}

void
operator<< (::xercesc::DOMElement& e, const Param& i)
{
  e << static_cast< const ::xml_schema::String& > (i);

  // name
  //
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "name",
        e));

    a << i.name ();
  }

  // lock
  //
  if (i.lock ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "lock",
        e));

    a << *i.lock ();
  }
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

